# SignalMonitor
# Copyright 2013 Artem Prilutskiy (R3ABM, cyanide.burnout@gmail.com)

# Generic routines

proc linearScale {value level1 strength1 level2 strength2} {
  set ratio [expr ($strength2 - $strength1) / ($level2 - $level1)]
  return [expr $strength1 + $value * $ratio]
}

proc scale {module value} {
  global functions
  set names [array names functions]
  if {[lsearch $names $module] >= 0} {
    set function $functions($module)
    return [$function $value]
  }
  return $value
}

proc registerScale {module function} {
  global functions
  set functions($module) $function
}

# Rig scale routines

proc CAT {value} {
  # This conversion has HamLib's specific with its "dB" scale
  # http://hamlib.sourceforge.net/manuals/1.2.15/group__rig.html#gadeb6d6c4d38bb005ee6df9fe375b6c49
  return [expr $value - 73.0]
}

proc RP2C {value} {
  return [linearScale $value 220 -128.0 921 -72.0]
}

proc Kenwood {value} {
  return [linearScale $value 1 -118.0 7 -96.0]
}
